// Copyright (c) Facebook, Inc. and its affiliates.
//
// This source code is licensed under the MIT license found in the
// LICENSE file in the "hack" directory of this source tree.
//
// @generated SignedSource<<1edbb9aa61b703f820c963d89714a825>>
//
// To regenerate this file, run:
//   hphp/hack/src/oxidized_regen.sh

use ocamlrep_derive::FromOcamlRep;
use ocamlrep_derive::ToOcamlRep;
use serde::Deserialize;
use serde::Serialize;

#[allow(unused_imports)]
use crate::*;

#[derive(
    Clone,
    Debug,
    Deserialize,
    FromOcamlRep,
    PartialEq,
    PartialOrd,
    Serialize,
    ToOcamlRep
)]
#[repr(C)]
pub struct GlobalOptions {
    pub tco_experimental_features: s_set::SSet,
    pub tco_migration_flags: s_set::SSet,
    pub tco_dynamic_view: bool,
    pub tco_num_local_workers: Option<isize>,
    pub tco_parallel_type_checking_threshold: isize,
    pub tco_max_typechecker_worker_memory_mb: Option<isize>,
    pub tco_defer_class_declaration_threshold: Option<isize>,
    pub tco_defer_class_memory_mb_threshold: Option<isize>,
    pub tco_max_times_to_defer_type_checking: Option<isize>,
    pub tco_prefetch_deferred_files: bool,
    pub tco_remote_type_check_threshold: Option<isize>,
    pub tco_remote_type_check: bool,
    pub tco_remote_worker_key: Option<String>,
    pub tco_remote_check_id: Option<String>,
    pub tco_remote_max_batch_size: isize,
    pub tco_remote_min_batch_size: isize,
    pub tco_num_remote_workers: isize,
    pub tco_stream_errors: bool,
    pub so_remote_version_specifier: Option<String>,
    pub so_remote_worker_vfs_checkout_threshold: isize,
    pub so_naming_sqlite_path: Option<String>,
    pub po_auto_namespace_map: Vec<(String, String)>,
    pub po_codegen: bool,
    pub po_deregister_php_stdlib: bool,
    pub po_disallow_toplevel_requires: bool,
    pub po_disable_nontoplevel_declarations: bool,
    pub po_allow_unstable_features: bool,
    pub tco_log_inference_constraints: bool,
    pub tco_disallow_array_typehint: bool,
    pub tco_disallow_array_literal: bool,
    pub tco_language_feature_logging: bool,
    pub tco_disallow_scrutinee_case_value_type_mismatch: bool,
    pub tco_timeout: isize,
    pub tco_disallow_invalid_arraykey: bool,
    pub tco_disallow_byref_dynamic_calls: bool,
    pub tco_disallow_byref_calls: bool,
    pub allowed_fixme_codes_strict: i_set::ISet,
    pub allowed_fixme_codes_partial: i_set::ISet,
    pub codes_not_raised_partial: i_set::ISet,
    pub log_levels: s_map::SMap<isize>,
    pub po_disable_lval_as_an_expression: bool,
    pub tco_shallow_class_decl: bool,
    pub tco_force_shallow_decl_fanout: bool,
    pub tco_force_load_hot_shallow_decls: bool,
    pub tco_skip_hierarchy_checks: bool,
    pub po_rust_parser_errors: bool,
    pub tco_like_type_hints: bool,
    pub tco_union_intersection_type_hints: bool,
    pub tco_coeffects: bool,
    pub tco_coeffects_local: bool,
    pub tco_strict_contexts: bool,
    pub tco_like_casts: bool,
    pub tco_simple_pessimize: f64,
    pub tco_complex_coercion: bool,
    pub error_codes_treated_strictly: i_set::ISet,
    pub tco_check_xhp_attribute: bool,
    pub tco_check_redundant_generics: bool,
    pub tco_disallow_unresolved_type_variables: bool,
    pub tco_disallow_trait_reuse: bool,
    pub tco_disallow_invalid_arraykey_constraint: bool,
    pub po_enable_class_level_where_clauses: bool,
    pub po_disable_legacy_soft_typehints: bool,
    pub po_allowed_decl_fixme_codes: i_set::ISet,
    pub po_allow_new_attribute_syntax: bool,
    pub tco_global_inference: bool,
    pub tco_gi_reinfer_types: Vec<String>,
    pub tco_ordered_solving: bool,
    pub tco_const_static_props: bool,
    pub po_disable_legacy_attribute_syntax: bool,
    pub tco_const_attribute: bool,
    pub po_const_default_func_args: bool,
    pub po_const_default_lambda_args: bool,
    pub po_disallow_silence: bool,
    pub po_abstract_static_props: bool,
    pub po_disable_unset_class_const: bool,
    pub po_parser_errors_only: bool,
    pub tco_check_attribute_locations: bool,
    pub glean_service: String,
    pub glean_hostname: String,
    pub glean_port: isize,
    pub glean_reponame: String,
    pub symbol_write_root_path: String,
    pub symbol_write_hhi_path: String,
    pub symbol_write_ignore_paths: Vec<String>,
    pub symbol_write_index_paths: Vec<String>,
    pub symbol_write_index_paths_file: Option<String>,
    pub symbol_write_index_paths_file_output: Option<String>,
    pub symbol_write_include_hhi: bool,
    pub po_disallow_func_ptrs_in_constants: bool,
    pub tco_error_php_lambdas: bool,
    pub tco_disallow_discarded_nullable_awaitables: bool,
    pub po_enable_xhp_class_modifier: bool,
    pub po_disable_xhp_element_mangling: bool,
    pub po_disable_xhp_children_declarations: bool,
    pub po_enable_enum_classes: bool,
    pub po_disable_modes: bool,
    pub po_disable_hh_ignore_error: bool,
    pub po_disable_array: bool,
    pub po_disable_array_typehint: bool,
    pub tco_enable_systemlib_annotations: bool,
    pub tco_higher_kinded_types: bool,
    pub tco_method_call_inference: bool,
    pub tco_report_pos_from_reason: bool,
    pub tco_typecheck_sample_rate: f64,
    pub tco_enable_sound_dynamic: bool,
    pub po_disallow_hash_comments: bool,
    pub po_disallow_fun_and_cls_meth_pseudo_funcs: bool,
    pub po_disallow_inst_meth: bool,
    pub po_enable_readonly_in_emitter: bool,
    pub po_escape_brace: bool,
    pub tco_use_direct_decl_parser: bool,
    pub tco_use_direct_decl_in_tc_loop: bool,
    pub tco_ifc_enabled: Vec<String>,
    pub po_enable_enum_supertyping: bool,
    pub po_interpret_soft_types_as_like_types: bool,
    pub tco_enable_strict_string_concat_interp: bool,
    pub tco_ignore_unsafe_cast: bool,
    pub tco_readonly: bool,
    pub tco_enable_expression_trees: bool,
    pub tco_enable_modules: bool,
    pub tco_allowed_expression_tree_visitors: Vec<String>,
    pub tco_math_new_code: bool,
    pub tco_typeconst_concrete_concrete_error: bool,
    pub tco_enable_strict_const_semantics: bool,
    pub tco_meth_caller_only_public_visibility: bool,
    pub tco_require_extends_implements_ancestors: bool,
    pub tco_strict_value_equality: bool,
    pub tco_enforce_sealed_subclasses: bool,
    pub tco_everything_sdt: bool,
    pub tco_deferments_light: bool,
    pub tco_old_naming_table_for_redecl: bool,
}
